Botan: Botan::Base64_Encoder Class Reference

Botan 1.10.17

Public Member Functions | Protected Member Functions | List of all members
Botan::Base64_Encoder Class Reference

`#include <b64_filt.h>`

Inheritance diagram for Botan::Base64_Encoder:

## Public Member Functions
virtual bool | attachable ()
| Base64_Encoder (bool breaks=false, size_t length=72, bool t_n=false)
void | end_msg ()
std::string | name () const
virtual void | start_msg ()
void | write (const byte input[], size_t length)

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

This class represents a Base64 encoder.

Definition at line 18 of file b64_filt.h.

## Constructor & Destructor Documentation

## ◆ Base64_Encoder()

Botan::Base64_Encoder::Base64_Encoder | ( | bool | breaks = `false`,
|  | size_t | length = `72`,
|  | bool | t_n = `false`
| ) |  |

Create a base64 encoder.

Parameters

  breaks | whether to use line breaks in the output
  length | the length of the lines of the output
  t_n | whether to use a trailing newline

Definition at line 19 of file b64_filt.cpp.

19 :
20 line_length(breaks ? length : 0),
21 trailing_newline(t_n && breaks),
22 in(48),
23 out(64),
24 position(0),
25 out_position(0)
26 {
27 }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::Base64_Encoder::end_msg | ( |  | ) |
| virtual

Inform the Encoder that the current message shall be closed.

Reimplemented from Botan::Filter.

Definition at line 103 of file b64_filt.cpp.

References Botan::Filter::send().

104 {
105 encode_and_send(&in[0], position, true);
106
107 if(trailing_newline || (out_position && line_length))
108 send('\n');
109
110 out_position = position = 0;
111 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ name()

std::string Botan::Base64_Encoder::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 21 of file b64_filt.h.

21 { return "Base64_Encoder"; }

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::MemoryRegion< T >::size(), and Botan::Filter::write().

Referenced by Botan::PK_Encryptor_Filter::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Hex_Encoder::end_msg(), end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:158
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

38 {}

## ◆ write()

void Botan::Base64_Encoder::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Input a part of a message to the encoder.

Parameters

  input | the message to input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 80 of file b64_filt.cpp.

References Botan::MemoryRegion< T >::copy(), and Botan::MemoryRegion< T >::size().

81 {
82 in.copy(position, input, length);
83 if(position + length >= in.size())
84 {
85 encode_and_send(&in[0], in.size());
86 input += (in.size() - position);
87 length -= (in.size() - position);
88 while(length >= in.size())
89 {
90 encode_and_send(input, in.size());
91 input += in.size();
92 length -= in.size();
93 }
94 in.copy(input, length);
95 position = 0;
96 }
97 position += length;
98 }
Botan::MemoryRegion::copy
void copy(const T in[], size_t n)
Definition: secmem.h:126
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

The documentation for this class was generated from the following files:

- src/filters/codec_filt/b64_filt.h
- src/filters/codec_filt/b64_filt.cpp